﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace SoundBottler
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        class Dev : IComparable
        {
            private string devstr;
            private NAudio.CoreAudioApi.MMDevice _dev;
            public NAudio.CoreAudioApi.MMDevice dev
            {
                get { return _dev; }
                set
                {
                    _dev = value;
                    devstr = (speaker() ? "( speaker )  " : "[ input ]  ") + dev.FriendlyName;
                }
            }
            public Dev(NAudio.CoreAudioApi.MMDevice dev)
            {
                this.dev = dev;
            }
            public override string ToString()
            {
                return devstr;
            }
            public bool speaker()
            {
                return
                    dev.DataFlow == NAudio.CoreAudioApi.DataFlow.All ||
                    dev.DataFlow == NAudio.CoreAudioApi.DataFlow.Render;
            }
            public bool test()
            {
                try
                {
                    NAudio.Wave.IWaveIn asdf = speaker() ?
                        new NAudio.Wave.WasapiLoopbackCapture(dev) :
                        new NAudio.CoreAudioApi.WasapiCapture(dev);
                    return true;
                }
                catch { }
                return false;
            }
            public int CompareTo(object obj)
            {
                var o = (Dev)obj;
                return ToString().CompareTo(o.ToString());
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            locker = new object();
            gDev.Enabled = gStart.Enabled = false;
            Application.DoEvents();

            Timer t = new Timer();
            t.Interval = 100;
            t.Tick += t_Tick;
            t.Start();

            trec = new Timer();
            trec.Interval = 100;
            trec.Tick += trec_Tick;
            //trec.Start();
        }

        void t_Tick(object sender, EventArgs e)
        {
            ((Timer)sender).Stop();
            string oldtext = gText.Text;
            gTime.ForeColor = SystemColors.ControlDark;
            gTime.Font = new System.Drawing.Font(gTime.Font.FontFamily, gTime.Font.Size * 5);

            NAudio.CoreAudioApi.MMDeviceEnumerator mde = new NAudio.CoreAudioApi.MMDeviceEnumerator();
            var devs = new List<Dev>();
            foreach (
                NAudio.CoreAudioApi.MMDevice device
                 in mde.EnumerateAudioEndPoints(
                    NAudio.CoreAudioApi.DataFlow.All,
                    NAudio.CoreAudioApi.DeviceState.All))
            {
                devs.Add(new Dev(device));
            }
            devs.Sort();
            for (int a = 0; a < devs.Count; a++)
            {
                gText.Text = "\nEvaluating your devices\n\n" + new string('/', devs.Count - a);
                Application.DoEvents();
                if (devs[a].test())
                {
                    gDev.Items.Add(devs[a]);
                }
            }
            try
            {
                gDev.SelectedIndex = Convert.ToInt32(File.ReadAllText("SoundBottler.ini"));
            }
            catch
            {
                gDev.SelectedIndex = 0;
            }

            gText.Text = oldtext;
            gDev.Enabled = gStart.Enabled = true;
            ticker = -1;
        }

        private void gDev_SelectedIndexChanged(object sender, EventArgs e)
        {
            File.WriteAllText("SoundBottler.ini", gDev.SelectedIndex.ToString());
        }

        double vu;
        Timer trec;
        int ticker;
        object locker;
        NAudio.Wave.IWaveIn wdt_waveIn;
        NAudio.Wave.WaveFileWriter wdt_writer;
        bool disposeOK;

        void fucking()
        {
            System.Threading.Thread.Sleep(1000);
            if (!disposeOK)
            {
                System.Diagnostics.Process.GetCurrentProcess().Kill();
            }
        }
        private void gStart_Click(object sender, EventArgs e)
        {
            lock (locker)
            {
                if (ticker >= 0)
                {
                    disposeOK = false;
                    new System.Threading.Thread(new System.Threading.ThreadStart(fucking)).Start();
                    gStart.Text = "w  a  i  t";
                    Application.DoEvents();

                    wdt_waveIn.StopRecording();
                    wdt_writer.Close();
                    wdt_waveIn.Dispose();
                    wdt_writer.Dispose();
                    disposeOK = true;
                    gDev.Enabled = true;
                    gTime.ForeColor = SystemColors.ControlDark;
                    gStart.Text = "S T A R T";
                    ticker = -1;
                    return;
                }
            }

            ticker = 0;
            gDev.Enabled = false;
            string fn = DateTime.Now.ToString("yyyy-MM-dd_HH.mm.ss.wav");
            Dev dev = (Dev)gDev.SelectedItem;
            wdt_waveIn = dev.speaker() ?
                new NAudio.Wave.WasapiLoopbackCapture(dev.dev) :
                new NAudio.CoreAudioApi.WasapiCapture(dev.dev);
            wdt_writer = new NAudio.Wave.WaveFileWriter(fn, wdt_waveIn.WaveFormat);
            wdt_waveIn.DataAvailable += wdt_OnDataAvailable;
            wdt_waveIn.StartRecording();

            gRate.Text = wdt_waveIn.WaveFormat.SampleRate + " Hz";
            gSize.Text = wdt_waveIn.WaveFormat.BitsPerSample + " bit";
            gCh.Text = wdt_waveIn.WaveFormat.Channels.ToString();
            gEnc.Text = wdt_waveIn.WaveFormat.Encoding.ToString();
            gTime.ForeColor = SystemColors.ControlText;
            gStart.Text = "S T O P";
            trec.Start();
        }
        void wdt_OnDataAvailable(object sender, NAudio.Wave.WaveInEventArgs e)
        {
            wdt_writer.Write(e.Buffer, 0, e.BytesRecorded);
            double max = 0;
            for (int a = 0; a < e.BytesRecorded; a+=4)
            {
                max = Math.Max(max, BitConverter.ToSingle(e.Buffer, a));
            }
            vu = Math.Max(max, vu);

            double secondsRecorded = wdt_writer.Length / wdt_writer.WaveFormat.AverageBytesPerSecond;
            lock (locker)
            {
                if (ticker >= 0)
                {
                    ticker = (int)secondsRecorded;
                }
            }
        }
        void trec_Tick(object sender, EventArgs e)
        {
            if (ticker < 0)
            {
                trec.Stop();
                return;
            }
            int min = ticker / 60;
            int sec = ticker % 60;
            gTime.Text = string.Format("{0:00}:{1:00}", min, sec);
            gVu.Width = (int)(groupBox2.Width * vu);
            //gVu.Text = vu.ToString();
            vu = 0;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (ticker >= 0)
            {
                gStart_Click(null, null);
            }
            System.Diagnostics.Process.GetCurrentProcess().Kill();
        }
    }
}
